commit de4a7e02c20effdc51978f1eab5bdaac9f517d79
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Thu Oct 28 23:07:09 2021 +0200

    Remove ObjectType and info it held (icons, mesh file, num of scrambles, shortname) from the JSON file.

diff --git a/src/main/java/org/distorted/objectlib/json/JsonReader.java b/src/main/java/org/distorted/objectlib/json/JsonReader.java
index 7a5d6d4a..a9f7b207 100644
--- a/src/main/java/org/distorted/objectlib/json/JsonReader.java
+++ b/src/main/java/org/distorted/objectlib/json/JsonReader.java
@@ -64,12 +64,11 @@ public class JsonReader
   private ObjectSticker[] mObjectSticker;
   private Static3D[] mAxis;
   private int[] mBasicAngle;
-  private String mLongName, mShortName, mInventor;
-  private String mSmallIcon, mMediumIcon, mBigIcon, mHugeIcon, mMeshFile;
+  private String mLongName, mInventor;
   private int mYearOfInvention, mComplexity;
   private int[] mNumLayers;
   private float mSize;
-  private int mNumScrambles, mScrambleType;
+  private int mScrambleType;
   private int[] mColor;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -92,16 +91,9 @@ public class JsonReader
   private void parseMetadata(JSONObject object) throws JSONException
     {
     mLongName        = object.getString("longname");
-    mShortName       = object.getString("shortname");
     mInventor        = object.getString("inventor");
     mYearOfInvention = object.getInt("year");
     mComplexity      = object.getInt("complexity");
-    mSmallIcon       = object.getString("icon_small");
-    mMediumIcon      = object.getString("icon_medium");
-    mBigIcon         = object.getString("icon_big");
-    mHugeIcon        = object.getString("icon_huge");
-    mMeshFile        = object.getString("mesh");
-    mNumScrambles    = object.getInt("num_scrambles");
     mSize            = (float)object.getDouble("size");
     mSolvedFuncIndex = object.getInt("solved_func");
     }
@@ -691,13 +683,6 @@ public class JsonReader
     return null;
     }
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public String getShortName()
-    {
-    return mShortName;
-    }
-
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public String getObjectName()
@@ -754,13 +739,6 @@ public class JsonReader
     return mSize;
     }
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public int getNumScrambles()
-    {
-    return mNumScrambles;
-    }
-
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getScrambleType()
diff --git a/src/main/java/org/distorted/objectlib/json/JsonWriter.java b/src/main/java/org/distorted/objectlib/json/JsonWriter.java
index 1feb662e..8b857278 100644
--- a/src/main/java/org/distorted/objectlib/json/JsonWriter.java
+++ b/src/main/java/org/distorted/objectlib/json/JsonWriter.java
@@ -36,7 +36,6 @@ import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
 import org.distorted.objectlib.main.TwistyObject;
-import org.distorted.objectlib.main.ObjectType;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
@@ -355,25 +354,12 @@ public class JsonWriter
     {
     JSONObject metadata = new JSONObject();
 
-    ObjectType type  = object.getObjectType();
-    String inventor  = object.getInventor();
-    String shortname = type.name();
-    String lowerShort= shortname.toLowerCase();
-    String longname  = object.getObjectName();
-
-    metadata.put("longname"     , longname );
-    metadata.put("shortname"    , shortname );
-    metadata.put("inventor"     , inventor);
-    metadata.put("year"         , object.getYearOfInvention());
-    metadata.put("complexity"   , object.getComplexity());
-    metadata.put("icon_huge"    , "h_"+lowerShort+".png");
-    metadata.put("icon_big"     , "b_"+lowerShort+".png");
-    metadata.put("icon_medium"  , "m_"+lowerShort+".png");
-    metadata.put("icon_small"   , "s_"+lowerShort+".png");
-    metadata.put("mesh"         , lowerShort+".dmesh");
-    metadata.put("num_scrambles", type.getNumScramble() );
-    metadata.put("size"         , object.getSize() );
-    metadata.put("solved_func"  , object.getSolvedFunctionIndex() );
+    metadata.put("longname"   , object.getObjectName() );
+    metadata.put("inventor"   , object.getInventor());
+    metadata.put("year"       , object.getYearOfInvention());
+    metadata.put("complexity" , object.getComplexity());
+    metadata.put("size"       , object.getSize() );
+    metadata.put("solved_func", object.getSolvedFunctionIndex() );
 
     return metadata;
     }